#include "main.h"
#include "calc.h"
#include "init.h"
#include "draw.h"
#include "hud.h"
#include "io.h"

void updatescene( ){
	int i;
	static unsigned int lrgun=0;
	GLfloat v,v1;

	/*Update ship speed and test whether the space brake has been fired*/

	if(s==1){
		ships[0].vy+=ts*0.03*sin(DEGTORAD*ships[0].xrot);
		ships[0].vxz=ts*0.03*cos(DEGTORAD*ships[0].xrot);
		ships[0].vx+=ships[0].vxz*sin(-DEGTORAD*ships[0].yrot);
		ships[0].vz+=ships[0].vxz*cos(DEGTORAD*ships[0].yrot);
	}
	if(w==1){
		ships[0].vy-=ts*0.03*sin(DEGTORAD*ships[0].xrot);
		ships[0].vxz=ts*0.03*cos(DEGTORAD*ships[0].xrot);
		ships[0].vx-=ships[0].vxz*sin(-DEGTORAD*ships[0].yrot);
		ships[0].vz-=ships[0].vxz*cos(DEGTORAD*ships[0].yrot);	
	}
	if(a==1){
		ships[0].vy+=ts*0.03*sin(DEGTORAD*ships[0].xrot);
		ships[0].vxz=ts*0.03*cos(DEGTORAD*ships[0].xrot);
		ships[0].vx+=ships[0].vxz*sin(-DEGTORAD*(ships[0].yrot+90));
		ships[0].vz+=ships[0].vxz*cos(DEGTORAD*(ships[0].yrot+90));
	}
	if(d==1){
		ships[0].vy-=ts*0.03*sin(DEGTORAD*ships[0].xrot);
		ships[0].vxz=ts*0.03*cos(DEGTORAD*ships[0].xrot);
		ships[0].vx-=ships[0].vxz*sin(-DEGTORAD*(ships[0].yrot+90));
		ships[0].vz-=ships[0].vxz*cos(DEGTORAD*(ships[0].yrot+90));
	}

	if(space==1){
		if(ships[0].vx<0)ships[0].vx+=0.1*ts;
		if(ships[0].vx>0)ships[0].vx-=0.1*ts;
		if(ships[0].vy<0)ships[0].vy+=0.1*ts;
		if(ships[0].vy>0)ships[0].vy-=0.1*ts;
		if(ships[0].vz<0)ships[0].vz+=0.1*ts;
		if(ships[0].vz>0)ships[0].vz-=0.1*ts;
	}

	/*limit the ships speed*/

	v=sqrt(ships[0].vx*ships[0].vx+
	  ships[0].vy*ships[0].vy+	
	  ships[0].vz*ships[0].vz);
	
	if(v>2*ts){
		ships[0].vx=ships[0].vx*(2*ts/v);
		ships[0].vy=ships[0].vy*(2*ts/v);
		ships[0].vz=ships[0].vz*(2*ts/v);
	}

	/*move the ship*/

	ships[0].px+=ships[0].vx;
	ships[0].py+=ships[0].vy;
	ships[0].pz+=ships[0].vz;


	/*Spawn fuel if the fule level is below 50....
	the code below may seem confusing, this is because 
	in the code the fuel is a special type of asteroid. 
	Doing this allowed me to doing the collision detection
	of the asteroids at the same time as the fuel. 
	asteroids.state determines the type of asteroids:
	4=fuel,3=big,2=medium,1=small,0=dead.*/

	if((ships[0].fuel<50)&&(refuel)){
		for(i=0;i<MAX_ASTEROIDS;i++){

			if(asteroids[i].state!=0)continue;

			asteroids[i].vx=0;
			asteroids[i].vy=0;
			asteroids[i].vz=0;
			asteroids[i].px=100;
			asteroids[i].py=100;
			asteroids[i].pz=100;
			asteroids[i].vxrot=0;
			asteroids[i].vyrot=0;
			asteroids[i].vzrot=0;
			asteroids[i].state=4;
			asteroids[i].hits=20;
			refuel=0;
			break;
		}
	}

	/*Update asteroids speed. To make a collision more likely the asteroids
	actually hunt the ship. However if the asteroids stray to far from the origin
	they hunt the origin instead, this stops the asteroids from spreading 
	themselves all over the sky box*/

	for(i=0;i<MAX_ASTEROIDS;i++){
		if(asteroids[i].state==0)continue;

		if((sqrt(pow(asteroids[i].px,2)+pow(asteroids[i].py,2)+pow(asteroids[i].pz,2))<150)&&(asteroids[i].state!=4)){
				v=sqrt(pow(asteroids[i].px-ships[0].px,2)+
		       	pow(asteroids[i].py-ships[0].py,2)+
			   	pow(asteroids[i].pz-ships[0].pz,2));
				asteroids[i].vx-=0.08*ts*(asteroids[i].px-ships[0].px)/v;
				asteroids[i].vy-=0.08*ts*(asteroids[i].py-ships[0].py)/v;
				asteroids[i].vz-=0.08*ts*(asteroids[i].pz-ships[0].pz)/v;		
		}
		else{
				v1=sqrt(pow(asteroids[i].px,2)+
		        pow(asteroids[i].py,2)+
		        pow(asteroids[i].pz,2));

				if(v1>0){
					asteroids[i].vx-=0.08*ts*asteroids[i].px/v1;
					asteroids[i].vy-=0.08*ts*asteroids[i].py/v1;
					asteroids[i].vz-=0.08*ts*asteroids[i].pz/v1;		
				}
		}

		/*limit the asteroids speed*/	
	
		v=sqrt(pow(asteroids[i].vx,2)+
		       pow(asteroids[i].vy,2)+
			   pow(asteroids[i].vz,2));

		if(v>ts*10){
			asteroids[i].vx = asteroids[i].vx*(ts*10/v);
			asteroids[i].vy = asteroids[i].vy*(ts*10/v);
			asteroids[i].vz = asteroids[i].vz*(ts*10/v);
		}
		
		/*move and rotate the asteroids*/

		asteroids[i].xrot+=asteroids[i].vxrot*ts;
		asteroids[i].yrot+=asteroids[i].vyrot*ts;
		asteroids[i].zrot+=asteroids[i].vzrot*ts;
		
		asteroids[i].px+=asteroids[i].vx*0.2;
		asteroids[i].py+=asteroids[i].vy*0.2;
		asteroids[i].pz+=asteroids[i].vz*0.2;
	}

	/*Spawn a new bullet if the mouse button is clicked*/
	
	if((mb1==1)&&(reload>0.3/ts)){
		reload=0;
		for(i=0;i<128;i++){

			if(bullets[i].state!=0)continue;

			if(audio)plasmaChannel=playsound(plasma,plasmaChannel);
			bullets[i].px=ships[0].px+3*pow(-1,lrgun%2)*sin(-DEGTORAD*(ships[0].yrot+90));
			bullets[i].py=ships[0].py;
			bullets[i].pz=ships[0].pz+3*pow(-1,lrgun%2)*cos(DEGTORAD*(ships[0].yrot+90));
			lrgun++;
			bullets[i].vy=-ships[0].vy+5*sin(DEGTORAD*ships[0].xrot);
			bullets[i].vx=-ships[0].vx+5*cos(DEGTORAD*ships[0].xrot)*sin(-DEGTORAD*ships[0].yrot);
			bullets[i].vz=-ships[0].vz+5*cos(DEGTORAD*ships[0].xrot)*cos(DEGTORAD*ships[0].yrot);
			bullets[i].state=1;	
			bullets[i].range=0;
			break;		
		}
	}

	/*move the bullets*/

	for(i=0;i<128;i++){

			if(bullets[i].state==0)continue;
			
			bullets[i].px-=bullets[i].vx;
			bullets[i].py-=bullets[i].vy;
			bullets[i].pz-=bullets[i].vz;			
			bullets[i].range++;
			if(bullets[i].range > 300/ts)bullets[i].state=0;
			
	}
}

void collidetect( ){

        /*ok. you have found the problem, relax, have break, get a coffee,
	its because the asteroids size arent half multiples of each other so 
	that when the spawn they _will_ overlap with _something_  */

	int i,j,k,size,num_new=0;
	GLfloat tmpvx,tmpvy,tmpvz,v;

	/*Array contains coordinates where smaller asteroids are spawned 
	relative to the old asteroid once it is destroyed*/	

	GLfloat new_xyz[NUM_NEW][3]={{0.5,0,0.5},{0.5,0,-0.5},{-0.5,0,-0.5},{-0.5,0,0.5}};

	finished=0;	

	for(j=0;j<MAX_ASTEROIDS;j++){
		if(asteroids[j].state==0)continue;
		
		size=pow(pow(2, asteroids[j].state+1),2);     /*size defined by 5*state... new definition: 2^(state+1) */
		if(asteroids[j].state!=4)finished=1;
		else size*=3;

		/*check to see whether a bullet has hit an asteroids*/		

		for(i=0;i<128;i++){	

			if(bullets[i].state==0)continue;

			if(((pow(bullets[i].px-asteroids[j].px,2)+
			     pow(bullets[i].py-asteroids[j].py,2)+
			     pow(bullets[i].pz-asteroids[j].pz,2))<size)
				 &&(bullets[i].state!=0)){
			
					bullets[i].state=0;
					asteroids[j].hits--;

					/*If an asteroids has taken the maximum number of hits 
					then it explodes into smaller asteroids*/
			
					if(asteroids[j].hits==0){
						if(audio)playsound(explo,explChannel);
						if(asteroids[j].state==4){
							asteroids[j].state=0;
							refuel=1;
						}
						else{
							kills++;
	
							/*Spawn smaller asteroids*/
			
							for(num_new=0;num_new<NUM_NEW;num_new++){
								for(k=0;k<MAX_ASTEROIDS;k++){
									if(asteroids[k].state!=0)continue;
							
									asteroids[k].vx = asteroids[j].vx + 2*new_xyz[num_new][0];	
									asteroids[k].vy = asteroids[j].vy + 2*((GLfloat)(rand())/RAND_MAX-0.5);
									asteroids[k].vz = asteroids[j].vz + 2*new_xyz[num_new][2];
									asteroids[k].px = asteroids[j].px + pow(2, asteroids[j].state+1)*new_xyz[num_new][0];
									asteroids[k].py = asteroids[j].py + pow(2, asteroids[j].state+1)*new_xyz[num_new][1];
									asteroids[k].pz = asteroids[j].pz + pow(2, asteroids[j].state+1)*new_xyz[num_new][2];
									asteroids[k].state = asteroids[j].state-1;
									asteroids[k].shape = num_new; /*This _could_ also FUCK UP if NUM_NEW > number of asteroid models : HACK! */
									asteroids[k].vxrot = ts * ((GLfloat)(rand())/RAND_MAX);
									asteroids[k].vyrot = ts * ((GLfloat)(rand())/RAND_MAX);
									asteroids[k].vzrot = ts * ((GLfloat)(rand())/RAND_MAX);
									asteroids[k].xrot = asteroids[j].xrot;
									asteroids[k].yrot = asteroids[j].yrot;
									asteroids[k].zrot = asteroids[j].zrot;
									asteroids[k].hits = 20;
									break;
								}
							}
							asteroids[j].state=0;
						}
					}
			}
		}

		v = pow(ships[0].px-asteroids[j].px,2)+
		    pow(ships[0].py-asteroids[j].py,2)+
		    pow(ships[0].pz-asteroids[j].pz,2);	
		
		/* Alert player each time a new asteroids strays too close */

		if((v<size*4)&&(asteroids[j].state!=4)){
			if(!asteroids[j].prox){
				asteroids[j].prox=1;
				if(audio)proxalertChannel=playsound(proxalert,proxalertChannel);
			}
			alert=1;
		}
		else{
				asteroids[j].prox=0;
		}

		/*Test whether the ship has hit an asteroids or fuel can*/

		if(v < size){
			if(asteroids[j].state==4){
				ships[0].fuel=100;
				refuel=1;
				asteroids[j].state=0;
			}
			else{
				return_to_menu();
				break;
			}
		}

		/*Test for no fuel*/

		if(ships[0].fuel<0)return_to_menu();

		/*make asteroids bounce when they collide by interchanging their velocities.
		this is VERY crap bounce asteroids: it takes no account of mass and does not
		allow glancing hits*/

		for(k=j+1; k<MAX_ASTEROIDS; k++){

				if(asteroids[k].state==0)continue;
				
				if(sqrt(pow(asteroids[j].px-asteroids[k].px,2)+
				        pow(asteroids[j].py-asteroids[k].py,2)+
				        pow(asteroids[j].pz-asteroids[k].pz,2))
                                <(pow(2, asteroids[j].state+1) + pow(2, asteroids[k].state+1))){

					tmpvx=asteroids[j].vx;
					tmpvy=asteroids[j].vy;
					tmpvz=asteroids[j].vz;
					asteroids[j].vx=asteroids[k].vx; /*((float)asteroids[k].state)/((float)asteroids[j].state);*/
					asteroids[j].vy=asteroids[k].vy; /*((float)asteroids[k].state)/((float)asteroids[j].state);*/
					asteroids[j].vz=asteroids[k].vz; /*((float)asteroids[k].state)/((float)asteroids[j].state);*/
					asteroids[k].vx=tmpvx;           /*((float)asteroids[j].state)/((float)asteroids[k].state);*/
					asteroids[k].vy=tmpvy;           /*((float)asteroids[j].state)/((float)asteroids[k].state);*/
					asteroids[k].vz=tmpvz;           /*((float)asteroids[j].state)/((float)asteroids[k].state);*/
				}
		}	
	}
	if(finished==0)mb1=0;
}

unsigned char handleKeyPress(SDL_keysym *keysym, int SDL_KEY_EVENT){

    unsigned char key=0;
    switch (keysym->sym){
	case SDLK_ESCAPE:
	 	return_to_menu();
		break;
	case SDLK_F1:
	    	if(SDL_KEY_EVENT==SDL_KEYDOWN){
			SDL_WM_ToggleFullScreen(surface);
			if((SDL_ShowCursor(SDL_QUERY))==SDL_ENABLE)SDL_ShowCursor(SDL_DISABLE);
		}
	    	break;
	case SDLK_w:
		if(SDL_KEY_EVENT==SDL_KEYDOWN)w=1;
		if(SDL_KEY_EVENT==SDL_KEYUP)w=0;
		break;
	case SDLK_s:
                if(SDL_KEY_EVENT==SDL_KEYDOWN)s=1;
                if(SDL_KEY_EVENT==SDL_KEYUP)s=0;
                break;
	case SDLK_a:
                if(SDL_KEY_EVENT==SDL_KEYDOWN)a=1;
                if(SDL_KEY_EVENT==SDL_KEYUP)a=0;
                break;
	case SDLK_d:
                if(SDL_KEY_EVENT==SDL_KEYDOWN)d=1;
                if(SDL_KEY_EVENT==SDL_KEYUP)d=0;
                break;
	case SDLK_SPACE:
                if(SDL_KEY_EVENT==SDL_KEYDOWN)space=1;
                if(SDL_KEY_EVENT==SDL_KEYUP)space=0;
                break;
	default:
	    	break;
    }
    if(((keysym->sym<=0x7e)&&(keysym->sym>=0x20))||(keysym->sym==0x8))key=keysym->sym;
    return key;
    
}

GLfloat calculate_timing(){	

	/*Scale the speed of the game appropriately*/

    	GLint t=0;
    	GLfloat seconds=0,fps=0;
	static GLint T0=0;
	static GLint Frames=0;
	
	Frames++;

    	t=SDL_GetTicks();
	
	
    	seconds=(t-T0)/1000.0;
    	fps=Frames/seconds;

	if(n>4){
    		ts=ts*n;
		ts+=(FRM_RTE/fps);
	}
        n++;
	ts=ts/n;
	T0=t;
	Frames=0;
	return seconds;
}

void return_to_menu(){
	mb1=0;
	menu=1;
	write_to_highescore_file();
}

