#include "main.h"
#include "main.h"
#include "calc.h"
#include "init.h"
#include "draw.h"
#include "hud.h"
#include "io.h"

int drawGLScene(){

    char print_buf[128];
	
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

    glLoadIdentity();

    glRotatef(ships[0].xrot,1.0f,0.0f,0.0f);
    glRotatef(ships[0].yrot,0.0f,1.0f,0.0f);

    glTranslatef(-ships[0].px,-ships[0].py,-ships[0].pz);

    
    draw_sky_box();
    draw_asteroids();
    draw_bullets();
    

    goto_ortho();
    	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND); 
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glBindTexture(GL_TEXTURE_2D,  texture[9]);
	glBegin(GL_QUADS);
        	glTexCoord2f(0.0f, 1.0f);    glVertex2f(430, 270);
        	glTexCoord2f(0.0f, 0.0f);    glVertex2f(430, 330);
        	glTexCoord2f(1.0f, 0.0f);    glVertex2f(370, 330);
        	glTexCoord2f(1.0f, 1.0f);    glVertex2f(370, 270);
    	glEnd(); 
	
	sprintf(print_buf,"Asteroids destroyed: %i/63  Fuel %i",kills,(int)ships[0].fuel);
	print_font(print_buf,10,580,0,1,0);

	if(alert){
		print_font("Warning! Proximity Alert!",300,450,1,0,0);
		alert=0;
	}
	
	if((ships[0].fuel<30)&&(ships[0].fuel>10))print_font("Warning! Fuel is Low",300,400,1,0,0);
	if(ships[0].fuel<10)print_font("WARNING, FUEL IS CRITICAL!",300,400,1,0,0);
	if(!finished)print_font("WELL DONE! YOU SAVED THE EARTH!",300,400,1,1,1);

	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
    exit_ortho();

    ships[0].fuel-=calculate_timing();

    SDL_GL_SwapBuffers();

    
	
	
    return(TRUE);
}


void draw_fuel(){
	glCallList(260);
}


void draw_sky_box(){
	glCallList(258);
}

void draw_asteroids(){

	int i;
	GLfloat ax,ay,az,s;
	for(i=0;i<MAX_ASTEROIDS;i++){

		if(asteroids[i].state==0)continue;

		ax=asteroids[i].px;
		ay=asteroids[i].py;
		az=asteroids[i].pz;
 		s = (GLfloat)pow(2,asteroids[i].state+1);
		glMatrixMode(GL_MODELVIEW);    
		glPushMatrix();
		glTranslatef(ax,ay,az);
		glScalef(s,s,s);
		glRotatef(-asteroids[i].yrot,0.0f,1.0f,0.0f);
		glRotatef(-asteroids[i].xrot,1.0f,0.0f,0.0f);
		glRotatef(-asteroids[i].zrot,0.0f,0.0f,1.0f);
		if(asteroids[i].state!=4){glCallList(261+asteroids[i].shape);}
		if(asteroids[i].state==4){draw_fuel();}
		glPopMatrix();
	}
}

void draw_bullets(){

	int i;
	GLfloat ax,ay,az;
	for(i=0;i<128;i++){

		if(bullets[i].state==0)continue;

		ax=bullets[i].px;
		ay=bullets[i].py;
		az=bullets[i].pz;	

		glDisable(GL_DEPTH_TEST);
		glEnable(GL_BLEND); 
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glMatrixMode(GL_MODELVIEW);    
		glPushMatrix();
		glTranslatef(ax,ay,az);
	
	        glRotatef(-ships[0].yrot,0.0f,1.0f,0.0f);
		glRotatef(-ships[0].xrot,1.0f,0.0f,0.0f);
	
		glCallList(259);
		
		glPopMatrix();
		glDisable(GL_BLEND);
		glEnable(GL_DEPTH_TEST);
	}
}

int playsound(Mix_Chunk *sound, int soundChannel){
	Mix_VolumeChunk(sound,volume);
	if(soundChannel>0){
		Mix_HaltChannel(soundChannel);
		Mix_PlayChannel(soundChannel,sound,0);		
	}
	else{
		soundChannel=Mix_PlayChannel(-1,sound,0);
	}
	return soundChannel;
}

