#include "main.h"
#include "init.h"
#include "draw.h"
#include "calc.h"
#include "hud.h"
#include "io.h"
#include "menu.h"

int main(int argc,char **argv){

	int done=0 ;
	unsigned char key=0;
    	SDL_Event event;

	ts=0;
	n=0;
	audio=0;
	volume=30;
        strncpy(name, getenv("USER"), 16);

	fprintf(stderr,"\n-=+* GLAsteroids v0.91 - Blud0t of Project Z - http://projectz.ath.cx *+=-\n\n");

	SDL_init();
    	initGL();

    	resizeWindow(SCREEN_WIDTH, SCREEN_HEIGHT);
    	init_objects( );	
	load_audio_and_textures();
	create_highscore_file();
	load_config();

    	while(!done){

		while(SDL_PollEvent(&event)){
			switch(event.type){

			case SDL_VIDEORESIZE:
				surface = SDL_SetVideoMode( event.resize.w,event.resize.h,16,videoFlags );
				if(!surface){
					fprintf(stderr,"Could not get a surface after resize...\n");
					Quit(1);
				}
				resizeWindow( event.resize.w, event.resize.h );
			break;

			case SDL_KEYDOWN:
			    key=handleKeyPress(&event.key.keysym,SDL_KEYDOWN);
			break;

			case SDL_KEYUP:
				handleKeyPress(&event.key.keysym,SDL_KEYUP);
   	            break;
		
			case SDL_MOUSEMOTION:
				ships[0].xrot+=((GLfloat)event.motion.yrel)/5;
 				ships[0].yrot+=((GLfloat)event.motion.xrel)/5;		
			break;
	
			case SDL_MOUSEBUTTONDOWN:
				mb1=1;
			break;

			case SDL_MOUSEBUTTONUP:
				mb1=0;
			break;
			
			case SDL_QUIT:
			    done=1;
				write_to_highescore_file();
			break;

			default:
			    break;
			}
		}
	
		if(menu){
			show_menu(menu, key, event.motion.x, event.motion.y);
			key=0;
		}

		else{
				SDL_ShowCursor(0);

				if(!finished&&mb1==1){
					write_to_highescore_file();
					menu=2;
					mb1=0;
				}
				if(finished)

				updatescene( );
				collidetect( );
				drawGLScene( );
				reload+=0.1;
		}
		usleep(100);
	}
	Quit(0);
    	return(0);
}
